From 2a2887cdabb13f709b9d7d1d1484c69dc1fd3fbd Mon Sep 17 00:00:00 2001
From: zubin <imzubin@localhost.localdomain>
Date: Jul 09 2019 11:42:36 +0000
Subject: [PATCH 6/18] paging


---

diff --git a/src/bodhi.template.last b/src/bodhi.template.last
new file mode 100644
index 0000000..2c7f41b
--- /dev/null
+++ b/src/bodhi.template.last
@@ -0,0 +1,34 @@
+[ FILL_IN_NVR_HERE ]
+
+# bugfix, security, enhancement, newpackage (required)
+type=
+
+# testing, stable
+request=testing
+
+# Bug numbers: 1234,9876
+bugs=
+
+# Severity: low, medium, high, urgent
+# This is required for security updates.
+# severity=unspecified
+
+
+# Here is where you give an explanation of your update.
+# Content can span multiple lines, as long as they are indented deeper than
+# the first line. For example,
+# notes=first line
+#     second line
+#     and so on
+notes=- Rebuilt.
+
+# Enable request automation based on the stable/unstable karma thresholds
+autokarma=True
+stable_karma=3
+unstable_karma=-3
+
+# Automatically close bugs when this marked as stable
+close_bugs=True
+
+# Suggest that users restart after update
+suggest_reboot=False
diff --git a/src/bodhiCalls.py b/src/bodhiCalls.py
index 12a916b..8d50874 100644
--- a/src/bodhiCalls.py
+++ b/src/bodhiCalls.py
@@ -1,11 +1,4 @@
-# import iniparse
-# import ini
-import requests
-import dnf
-from fedora.client.bodhi import Bodhi2Client
+from bodhi.client.bindings import BodhiClient
 import pprint
-args = {}
-
-
-x = bc.csrf()
-print(x)
\ No newline at end of file
+bc = BodhiClient()
+pprint.pprint(bc.query())
\ No newline at end of file
diff --git a/src/login.py b/src/login.py
new file mode 100644
index 0000000..c6edbcc
--- /dev/null
+++ b/src/login.py
@@ -0,0 +1,39 @@
+from PyQt5 import QtWidgets
+# from mainwindow import Ui_MainWindow
+
+class Login(QtWidgets.QDialog):
+    def __init__(self, parent=None):
+        super(Login, self).__init__(parent)
+        self.textName = QtWidgets.QLineEdit(self)
+        self.textPass = QtWidgets.QLineEdit(self)
+        self.buttonLogin = QtWidgets.QPushButton('Login', self)
+        self.buttonLogin.clicked.connect(self.handleLogin)
+        layout = QtWidgets.QVBoxLayout(self)
+        layout.addWidget(self.textName)
+        layout.addWidget(self.textPass)
+        layout.addWidget(self.buttonLogin)
+
+    def handleLogin(self):
+        if (self.textName.text() == 'foo' and
+            self.textPass.text() == 'bar'):
+            self.accept()
+        else:
+            QtWidgets.QMessageBox.warning(
+                self, 'Error', 'Bad user or password')
+
+class Window(QtWidgets.QMainWindow):
+    def __init__(self, parent=None):
+        super(Window, self).__init__(parent)
+        # self.ui = Ui_MainWindow()
+        # self.ui.setupUi(self)
+
+if __name__ == '__main__':
+
+    import sys
+    app = QtWidgets.QApplication(sys.argv)
+    login = Login()
+
+    if login.exec_() == QtWidgets.QDialog.Accepted:
+        window = Window()
+        window.show()
+        sys.exit(app.exec_())
\ No newline at end of file
diff --git a/src/login_window.py b/src/login_window.py
new file mode 100644
index 0000000..6bc80a4
--- /dev/null
+++ b/src/login_window.py
@@ -0,0 +1,53 @@
+# -*- coding: utf-8 -*-
+
+# Form implementation generated from reading ui file 'ui/Login.ui'
+#
+# Created by: PyQt5 UI code generator 5.12.2
+#
+# WARNING! All changes made in this file will be lost!
+
+from PyQt5 import QtCore, QtGui, QtWidgets
+
+
+class Ui_Dialog(object):
+    def setupUi(self, Dialog):
+        Dialog.setObjectName("Dialog")
+        Dialog.resize(250, 300)
+        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
+        sizePolicy.setHorizontalStretch(0)
+        sizePolicy.setVerticalStretch(0)
+        sizePolicy.setHeightForWidth(Dialog.sizePolicy().hasHeightForWidth())
+        Dialog.setSizePolicy(sizePolicy)
+        Dialog.setMinimumSize(QtCore.QSize(250, 300))
+        Dialog.setMaximumSize(QtCore.QSize(250, 300))
+        self.username = QtWidgets.QLineEdit(Dialog)
+        self.username.setGeometry(QtCore.QRect(10, 70, 231, 35))
+        self.username.setObjectName("username")
+        self.Password = QtWidgets.QLineEdit(Dialog)
+        self.Password.setGeometry(QtCore.QRect(10, 140, 231, 35))
+        self.Password.setObjectName("Password")
+        self.Login = QtWidgets.QPushButton(Dialog)
+        self.Login.setGeometry(QtCore.QRect(10, 180, 96, 35))
+        self.Login.setObjectName("Login")
+        self.skip = QtWidgets.QPushButton(Dialog)
+        self.skip.setGeometry(QtCore.QRect(140, 180, 96, 35))
+        self.skip.setObjectName("skip")
+        self.label = QtWidgets.QLabel(Dialog)
+        self.label.setGeometry(QtCore.QRect(10, 120, 141, 19))
+        self.label.setObjectName("label")
+        self.label_2 = QtWidgets.QLabel(Dialog)
+        self.label_2.setGeometry(QtCore.QRect(10, 50, 111, 19))
+        self.label_2.setObjectName("label_2")
+
+        self.retranslateUi(Dialog)
+        QtCore.QMetaObject.connectSlotsByName(Dialog)
+
+    def retranslateUi(self, Dialog):
+        _translate = QtCore.QCoreApplication.translate
+        Dialog.setWindowTitle(_translate("Dialog", "Login"))
+        self.Login.setText(_translate("Dialog", "Login"))
+        self.skip.setText(_translate("Dialog", "Skip"))
+        self.label.setText(_translate("Dialog", "Password"))
+        self.label_2.setText(_translate("Dialog", "Username"))
+
+
diff --git a/src/main.py b/src/main.py
index a114213..ac827d5 100644
--- a/src/main.py
+++ b/src/main.py
@@ -1,37 +1,92 @@
+# import system stuff
 import sys
 import json
+import pprint
+
 from window import Ui_MainWindow
+
+# UI libs
 from PySide2 import QtCore, QtGui, QtWidgets
 from PyQt5 import QtCore, QtGui, QtWidgets
 
+# import login controller
+from login import Login 
+
+
+#  import Fedora libs
+from bodhi.client.bindings import BodhiClient
+
 
 
-json_file = open("data/test.json","r")
-data = json.load(json_file)
 
 class Main():
         def __init__(self):
-        
+                # init application
                 app = QtWidgets.QApplication(sys.argv)
                 MainWindow = QtWidgets.QMainWindow()
                 self.ui = Ui_MainWindow()
                 self.ui.setupUi(MainWindow)
-        
-                self.fetch_list()
+                
+                # set assets
+                self.bugfix = QtGui.QPixmap("../assets/bugfix.png")
+                self.enhancement = QtGui.QPixmap("../assets/enhancement.png")
+                self.newpackage = QtGui.QPixmap("../assets/new_package.png")
+                self.security = QtGui.QPixmap("../assets/security.png")
+                
+                # set listeners
                 self.ui.listWidget.itemSelectionChanged.connect(self.selected)
                 self.ui.lineEdit.textEdited.connect(self.searching)
-                
-                self.image = QtGui.QPixmap("/home/imzubin/projects/fedora-gooey-karma/assets/image.png")
-        
+                self.ui.pushButton.clicked.connect(self.postKarma)
+                self.ui.fetchUpdatesButton.clicked.connect(self.fetchList)
+                self.ui.nextButton.clicked.connect(self.next_page)
+                self.ui.previousButton.clicked.connect(self.previous_page)
+                # Bodhi
+                self.bc = BodhiClient()
+
+
+
+                self.query_args = {
+                        "page" : "1",
+                        "rows_per_page" : "30"
+                }
+
                 MainWindow.show()
                 sys.exit(app.exec_())
+        
 
 
-        def fetch_list(self):
-                for p in data['updates']:
+        
+        def postKarma(self):
+                t = self.ui.listWidget.selectedItems()
+                print(self.bc.get_releases())
+                print(t[0].text())
+                pass
+
+        
+        
+        # fetch the list of updates
+        def fetchList(self):
+                self.ui.listWidget.clear()
+                self.data = self.bc.query(page=self.query_args["page"],rows_per_page=self.query_args["rows_per_page"])
+                for p in self.data['updates']:
                         self.ui.listWidget.addItem(p['title'])
 
-        def populate_comments(self, t):
+        # page controllers 
+        def next_page(self):
+                self.query_args["page"] = int(self.query_args["page"]) + 1
+                self.ui.PageNum.setText(str(self.query_args["page"]))
+
+
+        def previous_page(self):
+                if (int(self.query_args["page"]) > 1):
+                        self.query_args["page"] = int(self.query_args["page"]) - 1
+                self.ui.PageNum.setText(str(self.query_args["page"]))
+
+        
+        # selecting the update
+        
+        # populates comments in the section
+        def populateComments(self, t):
                 try:
                         for comments in t['comments']:
                                 comment = QtWidgets.QTreeWidgetItem()
@@ -42,12 +97,13 @@ class Main():
                                 self.ui.treeWidget_comment.insertTopLevelItem(0,comment)
                 except:
                         pass
+        
 
-
+        # changes the display text on selection.
         def selected(self):
                 try:
                         t = self.ui.listWidget.selectedItems()
-                        for p in data['updates']:
+                        for p in self.data['updates']:
                                 if p['title']== t[0].text():
                                         self.ui.Package_name_main.setText(p['title'])
                                         self.ui.Package_breif.setText(p['alias'])
@@ -58,20 +114,26 @@ class Main():
                                         self.ui.Karma.setText(str(p['karma']))
                                         self.ui.Release_notes.setText(p['notes'])
                                         self.ui.treeWidget_comment.clear()
-                                        self.ui.UpdateType.setPixmap(self.image)
-                                        self.populate_comments(p)
-                        
+                                        self.populateComments(p)
+                                        if(p["type"] == "enhancement"):  
+                                                self.ui.UpdateType.setPixmap(self.enhancement)
+                                        elif(p["type"] == "bugfix"):
+                                                self.ui.UpdateType.setPixmap(self.bugfix)                                                
+                                        elif(p["type"] == "security"):
+                                                self.ui.UpdateType.setPixmap(self.security)                                                
+                                        elif(p["type"] == "newpackage"):
+                                                self.ui.UpdateType.setPixmap(self.newpackage)                                                
                 except Exception as e:
                         print(e)
                         pass
 
+        
+        # using the search bar
         def searching(self):
-                with open("data/test.json") as json_file:
-                        data = json.load(json_file)
-                        self.ui.listWidget.clear()
-                        for p in data['updates']:
-                                if str(self.ui.lineEdit.text()) in p['title']:
-                                        self.ui.listWidget.addItem(p['title'])
+                self.ui.listWidget.clear()
+                for p in self.data['updates']:
+                        if str(self.ui.lineEdit.text()) in p['title']:
+                                self.ui.listWidget.addItem(p['title'])
 
 
 if __name__ == "__main__":
diff --git a/src/ui/Login.ui b/src/ui/Login.ui
new file mode 100644
index 0000000..d44ab9c
--- /dev/null
+++ b/src/ui/Login.ui
@@ -0,0 +1,109 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>Dialog</class>
+ <widget class="QDialog" name="Dialog">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>250</width>
+    <height>300</height>
+   </rect>
+  </property>
+  <property name="sizePolicy">
+   <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
+    <horstretch>0</horstretch>
+    <verstretch>0</verstretch>
+   </sizepolicy>
+  </property>
+  <property name="minimumSize">
+   <size>
+    <width>250</width>
+    <height>300</height>
+   </size>
+  </property>
+  <property name="maximumSize">
+   <size>
+    <width>250</width>
+    <height>300</height>
+   </size>
+  </property>
+  <property name="windowTitle">
+   <string>Login</string>
+  </property>
+  <widget class="QLineEdit" name="username">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>70</y>
+     <width>231</width>
+     <height>35</height>
+    </rect>
+   </property>
+  </widget>
+  <widget class="QLineEdit" name="Password">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>140</y>
+     <width>231</width>
+     <height>35</height>
+    </rect>
+   </property>
+  </widget>
+  <widget class="QPushButton" name="Login">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>180</y>
+     <width>96</width>
+     <height>35</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>Login</string>
+   </property>
+  </widget>
+  <widget class="QPushButton" name="skip">
+   <property name="geometry">
+    <rect>
+     <x>140</x>
+     <y>180</y>
+     <width>96</width>
+     <height>35</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>Skip</string>
+   </property>
+  </widget>
+  <widget class="QLabel" name="label">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>120</y>
+     <width>141</width>
+     <height>19</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>Password</string>
+   </property>
+  </widget>
+  <widget class="QLabel" name="label_2">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>50</y>
+     <width>111</width>
+     <height>19</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>Username</string>
+   </property>
+  </widget>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>
